/*
boingmode2 real
by Bladesinger
Big thanks to haya and Retrostation, wouldn't have been able to make this without you guys!
*/
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

local springDurationFrm = 15*TICRATE
local springPopUpDurationFrm = TICRATE/4

freeslot("SPR_BLSP")

local bluespring_info = CV_RegisterVar({
    name = "bluespring",
    defaultvalue = "Off",
    flags = CV_NETVAR|CV_CALL,
    possiblevalue = CV_OnOff,
    func = function(var)
        if var.value then
            chatprint("\x85 Red Springs")
			chatprint("Aim forwards + Use Item, launches you in your character's direction!") --Red Spring
			chatprint("\x82 Yellow Springs")
			chatprint("Neutral Aim + Use Item, gives you air-control!") --Yellow Spring
			chatprint("\x84 Blue Springs")
			chatprint("Aim Backwards + Use Item, launches you opposite of your character's direction!") --Blue Spring
			S_StartSound(nil, sfx_s1cc, player)
        end
    end
})

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + (master.height - FixedMul(master.scale, mo.height))
	end
end

local function givePogo(mo, mo2)
    if not (mo and mo.valid) then return end
    if not (mo2 and mo2.valid and mo2.player) then return end
    if mo.playerspawned
	and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) then
		if not mo2.player.kartstuff[k_pogospring] then
			mo2.player.kartstuff[k_pogospring] = 1
		end
    end
end
addHook("MobjCollide", givePogo, MT_YELLOWSPRING)


local function AirBrake(mo, mo2)
    if not (mo and mo.valid) then return end
    if not (mo2 and mo2.valid and mo2.player) then return end
    if mo.playerspawned
	and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) then
		mo2.airbrake = true
    end
end
addHook("MobjCollide", AirBrake, MT_BLUEDIAG)

local function AirBrakeHandler(mo)
	if not (mo and mo.valid and mo.player) then return end

	if mo.airbrake and not P_IsObjectOnGround(mo) then
		mo.momx = $/4
		mo.momy = $/4
		mo.airbrake = nil
	end
end
addHook("MobjThinker", AirBrakeHandler, MT_PLAYER)


local mo, spawnDist, a, ox, oy, spring
local function useSpring(p, cmd)
	mo = p.mo
	p.kartstuff[k_itemamount] = $-1
	K_PlayBoostTaunt(p.mo)
	
	if p.kartstuff[k_throwdir] == 1 then
--		print("Red Spring spawned.")
		spawnDist = mo.radius
		a = mo.angle
		ox = P_ReturnThrustX(mo, a, spawnDist)
		oy = P_ReturnThrustY(mo, a, spawnDist)
		spring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_REDDIAG)
		spring.angle = a
		K_FlipFromObject(spring, mo)
		spring.xItemDuration = 1
		spring.startHeight = mo.z
	elseif p.kartstuff[k_throwdir] == 0 then
--		print("Yellow Spring spawned.")
		spawnDist = mo.radius
		a = mo.angle
		spring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_YELLOWSPRING)
		K_FlipFromObject(spring, mo)
		spring.xItemDuration = 1
		spring.startHeight = mo.z
		spring.playerspawned = true
	elseif p.kartstuff[k_throwdir] == -1 then
--		print("Blue Spring spawned.")
		spawnDist = mo.radius + ((64*mapobjectscale)*-1)
		a = mo.angle
		ox = P_ReturnThrustX(mo, a, spawnDist)
		oy = P_ReturnThrustY(mo, a, spawnDist)
		spring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BLUEDIAG)
		spring.angle = a+180*ANG1
		K_FlipFromObject(spring, mo)
		spring.xItemDuration = 1
		spring.playerspawned = true
	end
end

local boingos = {MT_YELLOWSPRING, MT_REDDIAG, MT_BLUEDIAG}
for _,i in ipairs(boingos) do
	addHook("MobjThinker", function(mo)
		if mo.xItemDuration then
			mo.xItemDuration = $+1
			if mo.xItemDuration <= springPopUpDurationFrm then
				return
			elseif mo.xItemDuration == springPopUpDurationFrm then
				mo.flags = $&~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY)
			end
			
			if mo.xItemDuration > springDurationFrm then
				mo.xItemDuration = 0
				P_KillMobj(mo)
			end
		end
	end, i)
end

	local function Springas(p, i)
		return xItemLib.xItemNamespaces["XITEM_BLUESPRING"], 20
	end

if xItemLib then
	xItemLib.func.addItem{"XITEM_BLUESPRING", //Namespace
	"Blue Spring", //Friendly Name
	"K_ITBOGO", //HUD Graphic
	"K_ISBOGO", //HUD Small Graphic
	0, //Flags
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, //Race Odds
	{0, 0}, //Battle Odds
	false, //Get Item Function
	useSpring, //Use Item Function
	false, //HUD Item Function
	false, //Itemodds overrides
	Springas, //Result Item Function
	{1, {SPR_BLSP, A}}, //Dropped Item Frames
	false, //Show in the item roulette
	nil,
	nil}
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_BLUESPRING", {
		tipDescription1 = "",
		tipDescription2 = "",
		tipUsage1 = "",
		tipUsage2 = "",
	})
end